CON

  cols = vgatext#cols
  rows = vgatext#rows
  chrs = cols * rows

  screensize = cols * rows / 4
  
  toplastrow = rows - 20

  middlelastrow = rows - 17

  lastrow = rows - 1

OBJ

  vgatext : "vga_hires_text"

VAR

  'sync long - written to -1 by VGA driver after each screen refresh
  long  sync
  'screen buffer - could be bytes, but longs allow more efficient scrolling
  long  screen[screensize]
  'row colors
  word  colors[rows]
  'cursor control bytes
  byte  cx0, cy0, cm0, cx1, cy1, cm1

  long  col, row, color, flag

  long  dbgCol, dbgRow

PUB start(basepin) | i
  vgatext.start(basepin, @screen, @colors, @cx0, @sync)
  repeat i from 0 to 19
    colors[i] := %0000000011111100
  repeat i from 20 to lastrow
    colors[i] := %0000000000110000
  {
  cm0 := %110

  repeat i from 0 to toplastrow
    colors[i] := %%0020_3330

  repeat i from toplastrow to middlelastrow
    colors[i] := %%0100_1310    '%%3310_0000

  repeat i from middlelastrow to lastrow
    colors[i] := %%0000_0300
  }
  out($00)                      ' clear screen
  

PUB str(stringptr)

'' Print a zero-terminated string

  repeat strsize(stringptr)
    out(byte[stringptr++])


PUB dec(value) | i

'' Print a decimal number

  if value < 0
    -value
    out("-")

  i := 1_000_000_000

  repeat 10
    if value => i
      out(value / i + "0")
      value //= i
      result~~
    elseif result or i == 1
      out("0")
    i /= 10


PUB hex(value, digits)

'' Print a hexadecimal number

  value <<= (8 - digits) << 2
  repeat digits
    out(lookupz((value <-= 4) & $F : "0".."9", "A".."F"))


PUB bin(value, digits)

'' Print a binary number

  value <<= 32 - digits
  repeat digits
    out((value <-= 1) & 1 + "0")

PUB out(c) | i, k

'' Output a character
''
''     $00 = clear screen
''     $01 = home
''     $08 = backspace
''     $09 = tab (8 spaces per)
''     $0A = set X position (X follows)
''     $0B = set Y position (Y follows)
''     $0C = set color (color follows)
''     $0D = return
''  others = printable characters

  case flag
    $00: case c
           $00: longfill(@screen, $20_20_20_20, screensize)
                col := row := 0
                dbgCol := 0
                dbgRow := middlelastrow
           $01: col := row := 0
           $08: if col
                  col--
           $09: repeat
                  print(" ")
                while col & 7
           $0A..$0C: flag := c
                     return
           $0D: newline
           other: print(c)
    $0A: col := c // cols
    $0B: row := c // rows
    $0C: color := c & 7
  flag := 0

PRI print(c)

  screen.byte[row * cols + col] := c
  if ++col == cols
    newline

PRI newline | i

  col := 0
  if ++row == toplastrow
    row--
    bytemove(@screen, @screen + cols, constant((toplastrow - 1) * cols))
    bytefill(@screen + constant((toplastrow - 1) * cols), $20, cols)