CON
{{
Super Maze Mania
Copyright 2008 Thomas Watson
Version 1.0 for Demoboard
}}
  _clkmode = xtal1+pll16x
  _xinfreq = 5_000_000
  serEnable = false

obj
vga : "maze_mania_vga_driver"
key : "combokeyboard"
ser : "FullDuplexSerial"
sd : "fsrw"

var
byte lvlNum
word moves, score
'long lvlAddr
byte lvlData[810]
byte filename[14]

dat
{{
this is the level data
the level format is very simple
x position of enemy, y position of enemy, 255(end of level marker)
a 127 indicates an empty level block, 255 indicates end of level data
}}
'empty
title byte $0B, 27, $0A, 39
byte "**************************************", 13, $0A, 39
byte "****Super Maze Mania for Demoboard****", 13, $0A, 39
byte "*****Copyright 2008 Thomas Watson*****", 13, $0A, 39
byte "********Press any key to start********", 13, $0A, 39
byte "**************************************", 0

pub main | x, y, oldx, oldy, in
key.start(26)                    'start keyboard
vga.start(16)                    'start monitor
if \sd.mount(4)
  vga.str(string("Failed to mount SD card.", 13, "Press any key to reboot."))
  in := key.getkey
  reboot
vga.str(@title)
in := key.getkey
if serEnable
  ser.start(31, 30, 0, 9600)
begin                            'load and draw level
repeat                           'main game loop
  oldx := x                      'move x and y positions to the old positions
  oldy := y
  in := key.getkey               'get a key and process it
  if in == $CB                   'esc, quits
    quit                         
  elseif in == $C0 and x > 0     'left arrow
    x--                          'increment x direction
    in := logic(x, y, oldx, oldy)'go and process movement
  elseif in == $C1 and x < 19    'right arrow
    x++
    in := logic(x, y, oldx, oldy)
  elseif in == $C2 and y > 0     'up arrow
    y--
    in := logic(x, y, oldx, oldy)
  elseif in == $C3 and y < 19    'down arrow
    y++
    in := logic(x, y, oldx, oldy)
  
  elseif in == $D0
    makeLvl
    lvlNum := 20
    begin
    in := -1
  
  if in == -1                    'check for game over/win
    x := 0                       'clear variables
    y := 0
    oldx := 0
    oldy := 0
  
pub display(x, y, oldx, oldy)    'display new character position
gotoxy(oldx, oldy)               'and clear old position
vga.out(" ")
gotoxy(x, y)
vga.out("$")       
                           
pub begin | enem_x, enem_y, i
repeat
  vga.out(0)                     'clear screen
         'draw start and starting position of character
  loadLvl             'get level address and verify level
  vga.out(0)
  vga.str(string($0A, 19, $0B, 19, "@", $01, "$"))
  repeat i from 0 to 400 step 2  'draw level
    enem_x := byte[@lvlData][i]   'read x
    enem_y := byte[@lvlData][i+1] 'read y
    'waitcnt(clkfreq/200+cnt)
    if enem_x == 255 or enem_x == 127  'check if end of level or empty level
      quit
    'if enem_x == 0 and enem_y == 0
    '  next
    gotoxy(enem_x, enem_y)       'go to enemy position
    vga.out("#")                 'draw enemy
  if enem_x <> 127               'check for end of level
    quit
printStats(0, 0)                 'display moves etc.
  
pub gotoxy(x, y)                 'go to x and y position
vga.out($0A)                     'print x position command
vga.out(x)                       'print x position
vga.out($0B)
vga.out(y)

pub loadLvl | i, value, in       'load and verify a level
i := getFileName
filename[i] := "."
filename[i+1] := "m"
filename[i+2] := "l"
filename[i+3] := "i"
filename[i+4] := 0
value := sd.popen(@filename, "r")
if value == 0
  vga.out(0)
  value := sd.pread(@lvlData, 810)
  lvlData[value] := 0
  vga.str(@lvlData)
  in := key.getkey
filename[i] := "."
filename[i+1] := "m"
filename[i+2] := "m"
filename[i+3] := "l"
filename[i+4] := 0
value := sd.popen(@filename, "r")
if value == -1
  vga.str(string("Level not found", 13))
  in := key.getkey
  lvlData[0] := 127
else
  sd.pread(@lvlData, 810)
return @lvlData  
'lvlNum++                         'increment level number

pub logic(x, y, oldx, oldy) | in 'loop to display and calculate character position 
display(x, y, oldx, oldy)        'display character
moves++                          'increment moves made
score += 3                       'increment score x3 
in := collisionDetect(x, y)      'check if a collision with an enemy or exit has occured
printStats(x, y)                 'print moves etc.
if in == 1                       'check return value
  youWin                         'user has won
  in := key.getkey
  moves := 0
  score := 0
  begin                          'load next level
  return -1                      'return -1 to notify main loop to clear vars
elseif in == 2                   'user has lost
  gameOver
  in := key.getkey
  moves := 0
  score := 0
  lvlNum := 20
  begin
  return -1

pub collisionDetect(x, y) | i, enem_x, enem_y  'collision detection
repeat i from 0 to 400 step 2    'read level data
  enem_x := byte[@lvlData][i]     
  enem_y := byte[@lvlData][i+1]
  if enem_x == 255               'check for end of level
    quit
  'if enem_x == 0 and enem_y == 0
  '  next
  if x == enem_x and y == enem_y 'check for enemy at character position
    return 2                     'return 2 to notify that a game over has occured
if x == 19 and y == 19           'check if character is at exit
  return 1                       'return 1 to notify that a success has occured

pub youWin
vga.str(string($01, $0B, 20))
repeat 128*5
  vga.out(" ")
vga.str(string($01, $0B, 20, "You win! Congratulations!", 13, "Score = "))
vga.dec(score)
vga.str(string(" Moves = "))
vga.dec(moves)
vga.str(string(" Level = "))
vga.dec(lvlNum-1)
vga.str(string(13, "Press any key to continue."))

pub gameOver
vga.str(string($01, $0B, 20))
repeat 128*5
  vga.out(" ")
vga.str(string($01, $0B, 20, "You lost.", 13, "Score = "))
vga.dec(score)
vga.str(string(" Moves = "))
vga.dec(moves)
vga.str(string(" Level = "))
vga.dec(lvlNum-1)
vga.str(string(13, "Press any key to continue."))

pub printStats(x, y)
'vga.str(string($01, $0B, 20))
'repeat 128*5
'  vga.out(" ")
vga.str(string($01, $0B, 20))  
vga.str(string("Score = "))
vga.dec(score)
vga.str(string(" Moves = "))
vga.dec(moves)
vga.str(string(" Level = "))
vga.dec(lvlNum-1)
vga.out(13)
repeat 13
  vga.out(" ")
vga.out($0A)
vga.out(0)
vga.str(string("X = "))
vga.dec(x)
vga.str(string(" Y = "))
vga.dec(y)

pub makeLvl | addr, in, x, y, oldx, oldy, i, enem_x, enem_y, j
vga.out(0)
j := getFileName
filename[j] := "."
filename[j+1] := "m"
filename[j+2] := "m"
filename[j+3] := "l"
filename[j+4] := 0
sd.popen(@filename, "w")
vga.out(0)
vga.str(string($0A, 19, $0B, 19, "@", $01, "$"))
addr := @lvlData
oldx := 0
oldy := 0
x := 0
y := 0
repeat 1000
  oldx := x
  oldy := y
  in := key.getkey
  if in == $C0 and x > 0
    x--
    in := display(x, y, oldx, oldy)
  elseif in == $C1 and x < 19
    x++
    in := display(x, y, oldx, oldy)
  elseif in == $C2 and y > 0
    y--
    in := display(x, y, oldx, oldy)
  elseif in == $C3 and y < 19
    y++
    in := display(x, y, oldx, oldy)
  elseif in == $33
    byte[addr++] := x
    byte[addr++] := y
    sd.pputc(x)
    sd.pputc(y)
    gotoxy(x, y)
    vga.out("#")
  elseif in == $CB
    byte[addr++] := 255
    sd.pputc(255)
    sd.pclose
    filename[j] := "."
    'filename[j+1] := "m"
    filename[j+2] := "l"
    filename[j+3] := "i"
    'filename[j+4] := 0
    'vga.str(string("ERROR"))
    sd.popen(@filename, "w")
    vga.out(0)
    vga.str(string("Please enter level description: "))
   ' waitcnt(clkfreq+cnt)
    repeat
      in := key.getkey
      if in == $0D
        'filename[i] := 0
        sd.pclose
        quit
      'filename[i] := in
      vga.out(in)
      sd.pputc(in)
    quit
  elseif in == $D0
    gotoxy(0, 26)
    repeat i from 0 to 399 step 2
      enem_x := byte[@lvlData][i]
      enem_y := byte[@lvlData][i+1]
      if enem_x == 255
        quit
      vga.dec(enem_x)
      vga.out(" ")
      vga.dec(enem_y)
      vga.out(",")
      if serEnable
        ser.dec(enem_x)
        ser.tx(",")
        ser.dec(enem_y)
        ser.tx(",")  
  byte[addr] := 255
  repeat i from 0 to 1000 step 2
    enem_x := byte[@lvlData][i]
    enem_y := byte[@lvlData][i+1]
    if enem_x == 255
      quit
    gotoxy(enem_x, enem_y)
    vga.out("#")
  gotoxy(0, 20)
  repeat 13
    vga.out(" ")
  vga.out($0A)
  vga.out(0)
  vga.str(string("X = "))
  vga.dec(x)
  vga.str(string(" Y = "))
  vga.dec(y)    
  'if in == -1
  '  x := 0
  '  y := 0
  '  oldx := 0
  '  oldy := 0
pub getFileName | i, in
vga.str(string("Levels: ", 13))
dir
vga.str(string("Please enter level name: "))
repeat i from 0 to 8
  in := key.getkey
  if in == $0D
    filename[i] := 0
    quit
  elseif in == $D0
    quit
  filename[i] := in
  vga.out(in)
if in == $D0
  del
else
  return i

pub dir | i, addr
sd.opendir
repeat
  if sd.nextfile(@filename)
    quit
  repeat i from 0 to 13
    if byte[@filename][i] == "."
      byte[@filename][i] := 0
      addr := @filename+(i+1)
  if textComp(addr, string("MML"), 3)
    vga.str(@filename)
    vga.out(13)

pub textComp(str1,str2,len)
   repeat len
      if byte[str1++] <> byte[str2++]
         return false
   return true

pub del | i
vga.out(0)
vga.str(string("Deleting...", 13))
i := getFileName
'i := getFileName
filename[i] := "."
filename[i+1] := "m"
filename[i+2] := "l"
filename[i+3] := "i"
sd.popen(@filename, "d")
filename[i] := "."
filename[i+1] := "m"
filename[i+2] := "m"
filename[i+3] := "l"
sd.popen(@filename, "d")  
 